unit main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  VCL.FlexCel.Core, FlexCel.XlsAdapter, FlexCel.Report, FlexCel.Render, System.Generics.Collections;

type
  TDemo = class(TObject)
    col1: string;
    col2: string;
    col3: string;
  end;

  TfrmMain = class(TForm)
    btnGenerate: TButton;
    procedure btnGenerateClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  frmMain: TfrmMain;

implementation
uses UJoinTables, __UVirtualArrayProvider;

{$R *.dfm}

procedure TfrmMain.btnGenerateClick(Sender: TObject);
var
memoryStream, outputStream: TMemoryStream;
pdfStream: TFileStream;

xls: TXLSFile;
report: TFlexCelReport;
pdfExp: TFlexCelPdfExport;

JoinRangeList: TJoinTables;

rangeList1: TObjectList<TDemo>;
rangeList2: TObjectList<TDemo>;
demo: TDemo;
i: Integer;
begin
  memoryStream := TMemoryStream.Create;
  memoryStream.LoadFromFile('..\..\demo.xls');
  xls := nil;
  pdfexp := nil;
  JoinRangeList := nil;
  rangeList1 := nil; rangeList2 := nil;

  report := TFlexCelReport.create(true);

  try
    rangeList1 := TObjectList<TDemo>.create;
    rangeList2 := TObjectList<TDemo>.create;
    report.SetValue('value', 'dummy');
    for i := 0 to 49 do
    begin
      demo := TDemo.create;
      (demo as TDemo).col1 := 'value1: ' + System.Integer.ToString(i);
      (demo as TDemo).col2 := 'value2: ' + System.Integer.ToString(i);
      (demo as TDemo).col3 := 'value3: ' + System.Integer.ToString(i);
      if i mod 2 <> 0 then
        rangeList1.Add(demo)
      else
        rangeList2.Add(demo);
    end;

    JoinRangeList := TJoinTables.Create('test',
                      [TVirtualArrayDataTable.Create('test1', nil, nil, TListDataProvider<TDemo>.Create(rangeList1), false, false),
                       TVirtualArrayDataTable.Create('test2', nil, nil, TListDataProvider<TDemo>.Create(rangeList2), false, false)]);
    report.AddTable('test', JoinRangeList, TDisposeMode.DisposeAfterRun);

    xls := TXlsFile.create('..\..\demo.xls', true);
    FreeAndNil(memoryStream);
    memoryStream := TMemoryStream.Create;
    xls.Save(memoryStream);
    memoryStream.Position := 0;
    outputStream := TMemoryStream.Create;
    report.Run(memoryStream, outputStream);
    outputStream.SaveToFile('r:\output.xls');


    pdfExp := TFlexCelPdfExport.create;
    pdfExp.AllowOverwritingFiles := true;
    if pdfExp.Workbook = nil then
      pdfExp.Workbook := TXlsFile.create;
    outputStream.Position := 0;
    pdfExp.Workbook.Open(outputStream);

    pdfStream := TFileStream.Create('r:\output.pdf', fmCreate);
    pdfExp.BeginExport(pdfStream);
    pdfExp.ExportSheet;
    pdfExp.EndExport;
  finally
    FreeAndNil(pdfStream);
    FreeAndNil(memoryStream);
    FreeAndNil(outputStream);
    FreeAndNil(report);
    FreeAndNil(xls);
    if (PdfExp <> nil) then PdfExp.Workbook.Free;
    FreeAndNil(PdfExp);
    FreeAndNil(rangeList1);
    FreeAndNil(rangeList2);
  end;
end;




end.
